<template>
  <GI18nCard
    i18n="d_si.realListXMLList.title"
    :level="level"
    :card="card"
    :optional="optional"
    :wiki-entry="wikiEntry"
    @deleteElement="$emit('delete')"
  >
    <template #card-title-append>
      <v-spacer />
      <GDropDownMenu
        i18n="form.addElement"
        :available-elements="availableElements"
        icon="add"
        :btn-class="level === 'third' ? 'theme--light' : 'theme--dark'"
        @addElement="addElement"
      />
    </template>
    <v-row dense>
      <GCol cols="12">
        <XmlTextField
          v-model="value.labelXMLList"
          i18n="d_si.realListXMLList.label"
        />
      </GCol>
      <GCol cols="12">
        <XmlTextField
          v-model="value.valueXMLList"
          i18n="d_si.realListXMLList.value"
          validate="required decimalList"
          ns="si"
        />
      </GCol>
      <GCol cols="12">
        <XmlTextField
          v-model="value.unitXMLList"
          i18n="d_si.realListXMLList.unit"
          validate="required dsiUnitList"
          ns="si"
        />
      </GCol>
      <GCol cols="12">
        <XmlTextField
          v-model="value.dateTimeXMLList"
          i18n="d_si.realListXMLList.datetime"
          validate="dateTimeList"
          ns="si"
        />
      </GCol>
      <GCol cols="12">
        <ExpandedUncertaintyXMLList
          v-if="value.expandedUncXMLList"
          v-model="value.expandedUncXMLList"
          :level="level"
          optional
          @delete="deleteExpandedUncXMLList"
        />
      </GCol>
    </v-row>
  </GI18nCard>
</template>

<script>
import { ExpandedUncXMLListType } from "@d-ptb/dcc-js";
import XmlTextField from "../App/Form/XML/XmlTextField";
import GI18nCard from "~/components/App/Common/GI18nCard";
import GCol from "~/components/App/Common/GCol";
import ExpandedUncertaintyXMLList from "~/components/D-SI/ExpandedUncertaintyXMLList";
import { insertIf } from "~/assets/util/general";
import GDropDownMenu from "~/components/App/Common/GDropDownMenu.vue";

export default {
  name: "RealListXMLList",
  components: {
    GDropDownMenu,
    GCol,
    ExpandedUncertaintyXMLList,
    GI18nCard,
    XmlTextField,
  },
  props: {
    value: Object,
    updateAvailableElements: Function,
    card: Boolean,
    level: String,
    optional: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
      default: "dsi",
    },
  },
  computed: {
    availableElements() {
      return ["expandedUncertainty"]
        .filter((x) => !this.blacklist.includes(x))
        .map((x) => {
          return {
            text: this.$t(`d_si.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blacklist() {
      return [
        ...insertIf(this.value.expandedUncXMLList, "expandedUncertainty"),
      ];
    },
  },
  watch: {
    availableElements: {
      handler() {
        if (typeof this.updateAvailableElements === "function")
          this.updateAvailableElements(this.availableElements);
      },
      immediate: true,
      deep: true,
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "expandedUncertainty":
          this.$set(
            this.value,
            "expandedUncXMLList",
            new ExpandedUncXMLListType()
          );
          break;
      }
    },
    deleteExpandedUncXMLList() {
      confirm(this.$t("dcc.tables.expandedUncertaintyXMLList.confirmRemove")) &&
        this.$set(this.value, "expandedUncXMLList", undefined);
    },
  },
};
</script>
